#ifndef ARCH_H
#define ARCH_H

#include <string.h>

/* Type Definitions */

typedef unsigned int   unsigned_32bit;
typedef signed int     signed_32bit;
typedef unsigned short unsigned_16bit;
typedef signed short   signed_16bit;
typedef unsigned char  byte;

typedef signed_32bit   fixedpoint;
typedef float	       real;

#ifdef __GNUC__
#define HAS_INLINE
#define INLINE __inline__
#define CONST __const__
#else
#define INLINE
#define CONST
#endif

/* Memory Functions: */
#define HW_MemSet(ptr,chr,sze) memset(ptr,chr,sze*sizeof(byte))
#define HW_MemCpy(dst,src,sze) memcpy(dst,src,sze)

/* Fixed Point functions: */
extern INLINE CONST fixedpoint FpMult(fixedpoint a,fixedpoint b)
#ifdef HAS_INLINE
{
 signed long long res;
 res=((((signed long long)a)*((signed long long)b)+((long long)1<<15)))>>16;

 return (fixedpoint)res;
}
#else
;
#endif

extern INLINE CONST fixedpoint FpDiv(fixedpoint a,fixedpoint b)
#ifdef HAS_INLINE
{
  signed long long res;
  res=(((signed long long)a)<<16)/((signed long long)b);

  return (fixedpoint)res;
}
#else
;
#endif

#endif /* ARCH_H */


