#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#ifdef MSDOS
#include <pc.h>
#include <dos.h>
#include <conio.h>
#include <keys.h>
#endif

#include <arch.h>
#include <device.h>
#include <common.h>
#include <dbgmem.h>
#include <error.h>
#include "vector.h"
#include "zobject.h"
#include "object.h"
#include "engine.h"
#include "render.h"
#include "zsort.h"
#include "readobj.h"

byte *parrot;
int x=0,y=0;
ZObject *list;

#ifdef MSDOS

#define CLOCK_T uclock_t
#define CLOCK() uclock()
#define MYCLOCKS_PER_SEC UCLOCKS_PER_SEC

#define INITTERMINAL() 
#define GETKEY(var) var=getkey();

#elif defined(__GNUC__)

#define CLOCK_T clock_t
#define CLOCK() clock()
#define MYCLOCKS_PER_SEC CLOCKS_PER_SEC

#define INITTERMINAL() set_input_mode()
#define GETKEY(var) read(STDIN_FILENO,&var,1);

#endif

double timefunction(void (*function)(void),int times)
{
  double elapsed;
  CLOCK_T t1, t0;
  int i;
 
  t0=CLOCK();
  for (i=0;i<times;i++)
    function();
  t1=CLOCK();
  elapsed = (t1-t0)/((double) MYCLOCKS_PER_SEC);
  return elapsed/times;
}

#define ONE 65536

void drawflatpolys(void) 
{
  int i;
  ZFlatPoly *poly;

  poly=malloc(sizeof(ZFlatPoly));

  poly->ZValue=1000;
  poly->ObjType=TYPE_ZFLATPOLY;
  poly->Color=1;
  poly->ClockWise=1;
  poly->Intensity=ONE-1;
  poly->Vertices[0]=(100+x) *16;
  poly->Vertices[1]=(20+y)  *16;
  poly->Vertices[2]=(80+x)  *16;
  poly->Vertices[3]=(80+y)  *16;
  poly->Vertices[4]=(20+x)  *16;
  poly->Vertices[5]=(30+y)  *16;
  for (i=0;i<100;i++) {
    RenderZObject(poly);
  }

  HW_DisplayScreen();
}

void drawgoroudpolys(void) 
{
  int i;
  ZGoroudPoly *poly;

  poly=malloc(sizeof(ZGoroudPoly));

  poly->ZValue=1000;
  poly->ObjType=TYPE_ZGOROUDPOLY;
  poly->ClockWise=1;
  poly->Color=2;
  poly->Vertices[0]=(100+x) *16;
  poly->Vertices[1]=(20+y)  *16;
  poly->Vertices[2]=ONE-1;
  poly->Vertices[3]=(80+x)  *16;
  poly->Vertices[4]=(80+y)  *16;
  poly->Vertices[5]=ONE/2;
  poly->Vertices[6]=(20+x)  *16;
  poly->Vertices[7]=(30+y)  *16;
  poly->Vertices[8]=0;
  for (i=0;i<100;i++) {
    RenderZObject(poly);
  }

  HW_DisplayScreen();
}

void drawtexturepolys(void) 
{
  int i;
  ZTexturePoly *poly;

  poly=malloc(sizeof(ZTexturePoly));

  poly->ZValue=1000;
  poly->ObjType=TYPE_ZTEXTUREPOLY;
  poly->BitWidth=6;
  poly->ClockWise=1;
  poly->Texture=parrot;

  poly->Vertices[0]=(100+x) *16;
  poly->Vertices[1]=(20+y)  *16;
  poly->Vertices[2]=63 <<16;
  poly->Vertices[3]=0  <<16;
  poly->Vertices[4]=(80+x)  *16;
  poly->Vertices[5]=(80+y)  *16;
  poly->Vertices[6]=63 <<16;
  poly->Vertices[7]=63 <<16;
  poly->Vertices[8]=(20+x)  *16;
  poly->Vertices[9]=(30+y)  *16;
  poly->Vertices[10]=0 <<16;
  poly->Vertices[11]=0 <<16;
  for (i=0;i<100;i++) {
    RenderZObject(poly);
  }

  HW_DisplayScreen();
}

void drawdots(void) 
{
  int i;
  ZDot *dot;

  dot=malloc(sizeof(ZDot));

  dot->ZValue=1000;
  dot->ObjType=TYPE_ZDOT;
  for (i=0;i<100;i++) {
    dot->Color=100;
    dot->Vertices[0]=220 *16;
    dot->Vertices[1]=30  *16;
    RenderZObject(dot);
  }

  HW_DisplayScreen();
}

void main(void)
{
  double tid1=0.0,tid2=0.0,tid3=0.0,tid4=0.0;
  int fd;
  byte *pal;
  int c;
  int quit=0;
  int type=0;

  parrot=malloc(4096);
  fd=open("parrot.raw",OPEN_READ_BINARY);
  read(fd,parrot,4096);
  close(fd);

  pal=malloc(256*3);
  fd=open("standard.pal",OPEN_READ_BINARY);
  read(fd,pal,256*3);
  close(fd);

  if (!InitRenderer()) {
    printf("Couldn't init renderer\n");
    exit(1);
  }

  if (!HW_OpenScreen())
    exit(1);

  HW_SetPalette(pal);

  HW_MemSet(HW_OffscreenBuffer,0,64000);

  /*  tid3=timefunction(&drawdots,100); */
  tid1=timefunction(&drawflatpolys,30);
  tid4=timefunction(&drawtexturepolys,30);
  tid2=timefunction(&drawgoroudpolys,30);

/*      
  while (!quit) {
    while(kbhit()) {
      c=getch();
      switch(c) {
      case '6': x+=1; break;
      case '4': x-=1; break;
      case '8': y-=1; break;
      case '2': y+=1; break;
      case 'q': quit=1; break;
      case ' ': type=(type+1)%3; break;
      }
    }
    HW_MemSet(HW_OffscreenBuffer,200,64000);
    switch(type) {
      case 0: drawflatpolys(); break;
      case 1: drawgoroudpolys(); break;
      case 2: drawtexturepolys(); break;
    }
  }
*/
  HW_CloseScreen();

  printf("Time to draw 100 flat polys: %f miliseconds\n",tid1*1000); 
  printf("Time to draw 100 goroud polys: %f miliseconds\n",tid2*1000); 
  printf("Time to draw 100 texture polys: %f miliseconds\n",tid4*1000); 
/*  printf("Time to draw 100 dots: %f miliseconds\n",tid3*1000); */

  /*  tid=timefunction(&HW_DisplayScreen,10000); */
  /* printf("Time to redraw screen: %f miliseconds\n",tid*1000); */
  
  /* while (!kbhit()) ;  */

}



